
// HandWheelDlg.cpp: 实现文件
//

#include "pch.h"
#include "framework.h"
#include "手轮.h"
#include "HandWheelDlg.h"
#include "afxdialogex.h"
#include"MC_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// 用于应用程序“关于”菜单项的 CAboutDlg 对话框

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// 对话框数据
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 支持

// 实现
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CHandWheelDlg 对话框



CHandWheelDlg::CHandWheelDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_MY_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	multi = 0;
}

void CHandWheelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, multi);
	DDX_Control(pDX, IDC_COMBO1, axisNoCombobox);
	DDX_Control(pDX, IDC_COMBO2, encCountMode);
	DDX_Control(pDX, IDC_COMBO3, encCountDir);
}

BEGIN_MESSAGE_MAP(CHandWheelDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CHandWheelDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CHandWheelDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON4, &CHandWheelDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON3, &CHandWheelDlg::OnBnClickedButton3)
	ON_WM_DESTROY()
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CHandWheelDlg 消息处理程序

BOOL CHandWheelDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// 将“关于...”菜单项添加到系统菜单中。

	// IDM_ABOUTBOX 必须在系统命令范围内。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// 设置此对话框的图标。  当应用程序主窗口不是对话框时，框架将自动
	//  执行此操作
	SetIcon(m_hIcon, TRUE);			// 设置大图标
	SetIcon(m_hIcon, FALSE);		// 设置小图标

	// TODO: 在此添加额外的初始化代码

#pragma region 开卡
	WORD pciNum = 0; //用于接收开卡成功的卡数
	WORD pcieIndex[12];
	DWORD functionReturn = 0; //函数返回值
	functionReturn = MC_Open(0, CONNECTION_PCI, "", &pciNum, pcieIndex);
	if (functionReturn == 0)//函数成功执行
	{
		if (pciNum > 0)//至少一张卡被成功开卡
		{
			cardConnectNo = pcieIndex[0]; //如果有多卡的情况下这里也只用卡1演示

#pragma region 获取卡信息
			//--------------------------获取卡信息------------------------------------------------------------------------
			WORD totalAxisNum = 0; //用于获取卡的轴数
			WORD linerNum = 0;//用于获取卡的插补系个数
			WORD totalInNum = 0;//用于获取卡的输入口数量
			WORD totalOutNum = 0;//用于获取卡的输出口数量
			WORD totalPWMNum = 0;//用于获取卡的PWM通道数量
			functionReturn = MC_GetTotalAxesAndIONum(cardConnectNo, &totalAxisNum, &linerNum, &totalInNum, &totalOutNum, &totalPWMNum);
			for (int axisNo = 0; axisNo < totalAxisNum; axisNo++)
			{
				CString str;
				str.Format(_T("%d"), axisNo);
				axisNoCombobox.AddString(str);
			}
			axisNoCombobox.SetCurSel(0);//设置轴号ComboBox默认选择

			encCountMode.AddString(L"脉冲方向计数");
			encCountMode.AddString(L"AB相计数，1倍频");
			encCountMode.AddString(L"AB相计数，2倍频");
			encCountMode.AddString(L"AB相计数，4倍频");

			encCountDir.AddString(L"计数方向不取反");
			encCountDir.AddString(L"计数方向取反");

			WORD mode = 0;
			WORD dir = 0;
			MC_GetAuxEncoderPrm(cardConnectNo, //获取卡默认设置的编码器模式
				0,
				&mode,
				&dir);
			encCountMode.SetCurSel(mode);//设置编码器模式下拉框
			encCountDir.SetCurSel(dir); //设置编码器方向下拉框

			//------------------------------------------------------------------------------------------------------------
#pragma endregion
			SetTimer(1, 200, NULL);//启动界面监控定时器

		}
		else
		{
			MessageBox(L"未找到卡!");
		}
	}
	else
	{
		MessageBox(L"开卡失败!");
	}
#pragma endregion

	return TRUE;  // 除非将焦点设置到控件，否则返回 TRUE
}

void CHandWheelDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// 如果向对话框添加最小化按钮，则需要下面的代码
//  来绘制该图标。  对于使用文档/视图模型的 MFC 应用程序，
//  这将由框架自动完成。

void CHandWheelDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 用于绘制的设备上下文

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 使图标在工作区矩形中居中
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 绘制图标
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

//当用户拖动最小化窗口时系统调用此函数取得光标
//显示。
HCURSOR CHandWheelDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


/// <summary>
/// 位置清除按钮点击事件
/// </summary>
void CHandWheelDlg::OnBnClickedButton1()
{
	// TODO: 在此添加控件通知处理程序代码
	WORD axisNo = axisNoCombobox.GetCurSel();//轴号
	MC_SetAxisCmdPos(cardConnectNo, axisNo, 0);//指令位置清零

	MC_SetAuxEncoderPositon(cardConnectNo, 0, 0); //辅助编码器值清零
}

/// <summary>
/// 执行运动按钮点击事件
/// </summary>
void CHandWheelDlg::OnBnClickedButton2()
{
	// TODO: 在此添加控件通知处理程序代码
	UpdateData(true); //用于将屏幕上控件中的数据交换到变量中


	WORD axisNo = axisNoCombobox.GetCurSel();//轴号

	MC_Power(cardConnectNo, axisNo, 1); //轴使能，轴使能之后才能够通过指令启动运动发出脉冲

	MC_SetAuxEncoderPrm(cardConnectNo,
		0,
		encCountMode.GetCurSel(),
		encCountDir.GetCurSel()); //设置辅助编码器计数模式

	MC_SetHandleWheelPrm(cardConnectNo,
		axisNo, 0, multi); //设置手轮参数
	MC_StartHandleWheel(cardConnectNo, axisNo); //启动手轮运动

	UpdateData(false);//用于将数据在屏幕中对应控件中显示出来

}

/// <summary>
/// 停止运动按钮点击事件
/// </summary>
void CHandWheelDlg::OnBnClickedButton4()
{
	// TODO: 在此添加控件通知处理程序代码
	WORD axisNo = axisNoCombobox.GetCurSel();//轴号

	//参数三，stop_mode = 0时停止模式为减速停止，=1时为立即停止
	//参数四，stop_time为减速停止时的减速时间
	MC_StopAxis(cardConnectNo, axisNo, 0, 0.1);
}


/// <summary>
/// 紧急停止按钮点击事件
/// </summary>
void CHandWheelDlg::OnBnClickedButton3()
{
	// TODO: 在此添加控件通知处理程序代码
	MC_StopEmgImd(cardConnectNo); //急停函数，所有轴立即停止

}


void CHandWheelDlg::OnDestroy()
{
	CDialogEx::OnDestroy();

	// TODO: 在此处添加消息处理程序代码
	KillTimer(1);
	MC_Close(cardConnectNo); //关卡释放资源
}


void CHandWheelDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: 在此添加消息处理程序代码和/或调用默认值
	WORD axisNo = axisNoCombobox.GetCurSel();//轴号
	double cmdPos = 0;
	MC_GetAxisCmdPos(cardConnectNo, axisNo, &cmdPos);//获取当前指令位置
	CString cmdPosStr;
	cmdPosStr.Format(_T("%f"), cmdPos);
	GetDlgItem(IDC_EDIT3)->SetWindowTextW(cmdPosStr); //设置到界面

	double cmdSpeed = 0;
	MC_GetAxisCmdSpeed(cardConnectNo, axisNo, &cmdSpeed); //获取当前指令速度
	CString cmdSpeedStr;
	cmdSpeedStr.Format(_T("%f"), cmdSpeed);
	GetDlgItem(IDC_EDIT2)->SetWindowTextW(cmdSpeedStr); //设置到界面

	WORD checkDone = 1;
	MC_GetAxisCheckDone(cardConnectNo, axisNo, &checkDone);//获取轴运动状态
	switch (checkDone)
	{
	case 0:
		GetDlgItem(IDC_EDIT5)->SetWindowTextW(L"运动中");
		break;
	case 1:
		GetDlgItem(IDC_EDIT5)->SetWindowTextW(L"空闲");
		break;
	default:
		CString checkDoneStr;
		checkDoneStr.Format(_T("%d"), checkDone);
		GetDlgItem(IDC_EDIT5)->SetWindowTextW(checkDoneStr);
		break;
	}

	double handWheelEncoderPos = 0;
	MC_GetAuxEncoderPositon(cardConnectNo, 0, &handWheelEncoderPos); //获取辅助编码器值
	CString handWheelEncoderPosStr;
	handWheelEncoderPosStr.Format(_T("%f"), handWheelEncoderPos);
	GetDlgItem(IDC_EDIT4)->SetWindowTextW(handWheelEncoderPosStr); //设置到界面

	CDialogEx::OnTimer(nIDEvent);
}
